<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
   
   <meta name="description" content="FLUBIO - An unstructured, parallel, finite volume Navier-Stokes solver for teaching and research purposes">
    
    <meta name="author" content="Edoardo Alinovi and Joel Guerrero" >
    <link rel="icon" href="../favicon.png">

    <title>expand &ndash; FLUBIO</title>

    <link href="../css/bootstrap.min.css" rel="stylesheet">
    <link href="../css/pygments.css" rel="stylesheet">
    <link href="../css/font-awesome.min.css" rel="stylesheet">
    <link href="../css/local.css" rel="stylesheet">
    
    <link  href="../tipuesearch/tipuesearch.css" rel="stylesheet">
    
    

    <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
    <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
    
    <script src="../js/jquery-2.1.3.min.js"></script>
    <script src="../js/svg-pan-zoom.min.js"></script>

  </head>

  <body>

    <!-- Fixed navbar -->
    <nav class="navbar navbar-inverse navbar-fixed-top">
      <div class="container">
        <div class="navbar-header">
          <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar">
            <span class="sr-only">Toggle navigation</span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
          <a class="navbar-brand" href="../index.html">FLUBIO </a>
        </div>
        <div id="navbar" class="navbar-collapse collapse">
          <ul class="nav navbar-nav">
        
            <li class="dropdown hidden-xs visible-sm visible-md hidden-lg">
              <a href="#" class="dropdown-toggle"
              data-toggle="dropdown" role="button"
              aria-haspopup="true"
     aria-expanded="false">Contents <span class="caret"></span></a>
        <ul class="dropdown-menu">
          
              
            <li><a href="../lists/files.html">Source Files</a></li>
        
        
        
            <li><a href="../lists/modules.html">Modules</a></li>
        
            
                                
            <li><a href="../lists/procedures.html">Procedures</a></li>
        
               
            <li><a href="../lists/types.html">Derived Types</a></li>
        
        
            <li><a href="../lists/programs.html">Programs</a></li>
               
        
        
            </ul>
        
            </li>


<li class="visible-xs hidden-sm visible-lg"><a href="../lists/files.html">Source Files</a></li>



<li class="visible-xs hidden-sm visible-lg"><a href="../lists/modules.html">Modules</a></li>



<li class="visible-xs hidden-sm visible-lg"><a href="../lists/procedures.html">Procedures</a></li>

                             
<li class="visible-xs hidden-sm visible-lg"><a href="../lists/types.html">Derived Types</a></li>


<li class="visible-xs hidden-sm visible-lg"><a href="../lists/programs.html">Programs</a></li>



          </ul>
        
        <form action="../search.html" class="navbar-form navbar-right" role="search">
        <div class="form-group">
          <input type="text" class="form-control" placeholder="Search" name="q" id="tipue_search_input" autocomplete="off" required>
        </div>
<!--
        <button type="submit" class="btn btn-default">Submit</button>
-->
        </form>
        
        </div><!--/.nav-collapse -->
      </div>
    </nav>

    <div class="container">
    
  
  <div class="row">
    <h1>expand
      <small>Function</small>
    
    </h1>
    
<div class="row">
  <div class="col-lg-12">
<div class="well well-sm">
  <ul class="list-inline" style="margin-bottom:0px;display:inline">
     
     
     
    <li><i class="fa fa-legal"></i> <a rel="license" href="http://creativecommons.org/licenses/by-nc/4.0/"><img alt="Creative Commons License" style="border-width:0" src="https://i.creativecommons.org/l/by-nc/4.0/80x15.png" /></a></li> 
     
     
     
    
    
     <li><i class="fa fa-list-ol"></i>
       <a data-toggle="tooltip"
    data-placement="bottom" data-html="true"
    title=" 0.4% of total for procedures.">73 statements</a>
     </li> 
     
     
     
    <li><i class="fa fa-code"></i><a href="../src/mstrings.f03"> Source File</a></li>
     
     
  </ul>
  <ol class="breadcrumb in-well text-right">
  
    
     <li><a href='../sourcefile/mstrings.f03.html'>mstrings.f03</a></li>
    
     <li><a href='../module/m_strings.html'>M_strings</a></li>
    
  
     <li class="active">expand</li>
  </ol>
</div>
</div>
</div>
<script>
  $(function () {
  $('[data-toggle="tooltip"]').tooltip()
  })
</script>

  </div>
  
  <div class="row">
    <div class="col-md-3 hidden-xs hidden-sm visible-md visible-lg">
    
<div id="sidebar">
  
<h3>Contents</h3>
 





















<em>None</em>


</div>

    </div>
    
    <div class="col-md-9" id='text'>
    <h2>
public function expand(line, escape) result(lineout)
    
    
   
</h2>
    
  
    <div class="panel panel-default">
      <div class="panel-heading">
  <h3 class="panel-title">Uses</h3>
      </div>
      <ul class="list-group">
      
      <li class="list-group-item">
  <ul class="list-inline">
    
    <li><a href="http://fortranwiki.org/fortran/show/iso_c_binding">iso_c_binding</a></li>
    
  </ul>
      </li>
      
      
      
      <li class="list-group-item">
  <div class="depgraph"><?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN"
 "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
<!-- Generated by graphviz version 2.40.1 (20161225.0304)
 -->
<!-- Title: proc~~expand~~UsesGraph Pages: 1 -->
<svg id="procexpandUsesGraph" width="176pt" height="32pt"
 viewBox="0.00 0.00 176.00 32.00" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
<g id="proc~~expand~~UsesGraph" class="graph" transform="scale(1 1) rotate(0) translate(4 28)">
<title>proc~~expand~~UsesGraph</title>
<polygon fill="#ffffff" stroke="transparent" points="-4,4 -4,-28 172,-28 172,4 -4,4"/>
<!-- proc~expand -->
<g id="proc~~expand~~UsesGraph_node1" class="node">
<title>proc~expand</title>
<polygon fill="none" stroke="#000000" points="168,-24 114,-24 114,0 168,0 168,-24"/>
<text text-anchor="middle" x="141" y="-9.6" font-family="Helvetica,sans-Serif" font-size="10.50" fill="#000000">expand</text>
</g>
<!-- iso_c_binding -->
<g id="proc~~expand~~UsesGraph_node2" class="node">
<title>iso_c_binding</title>
<g id="a_proc~~expand~~UsesGraph_node2"><a xlink:href="http://fortranwiki.org/fortran/show/iso_c_binding" xlink:title="iso_c_binding">
<polygon fill="#337ab7" stroke="#337ab7" points="78,-24 0,-24 0,0 78,0 78,-24"/>
<text text-anchor="middle" x="39" y="-9.6" font-family="Helvetica,sans-Serif" font-size="10.50" fill="#ffffff">iso_c_binding</text>
</a>
</g>
</g>
<!-- proc~expand&#45;&gt;iso_c_binding -->
<g id="proc~~expand~~UsesGraph_edge1" class="edge">
<title>proc~expand&#45;&gt;iso_c_binding</title>
<path fill="none" stroke="#000000" stroke-dasharray="5,2" d="M113.9337,-12C106.0435,-12 97.1649,-12 88.352,-12"/>
<polygon fill="#000000" stroke="#000000" points="88.0998,-8.5001 78.0997,-12 88.0997,-15.5001 88.0998,-8.5001"/>
</g>
</g>
</svg>
</div><div><a type="button" class="graph-help" data-toggle="modal" href="#graph-help-text">Help</a></div><div class="modal fade" id="graph-help-text" tabindex="-1" role="dialog"><div class="modal-dialog modal-lg" role="document"><div class="modal-content"><div class="modal-header"><button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button><h4 class="modal-title" id="-graph-help-label">Graph Key</h4></div><div class="modal-body">
    <p>Nodes of different colours represent the following: </p>
    <?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN"
 "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
<!-- Generated by graphviz version 2.40.1 (20161225.0304)
 -->
<!-- Title: Graph Key Pages: 1 -->
<svg width="490pt" height="32pt"
 viewBox="0.00 0.00 489.50 32.00" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
<g id="graph0" class="graph" transform="scale(1 1) rotate(0) translate(4 28)">
<title>Graph Key</title>
<polygon fill="#ffffff" stroke="transparent" points="-4,4 -4,-28 485.5,-28 485.5,4 -4,4"/>
<!-- Module -->
<g id="node1" class="node">
<title>Module</title>
<polygon fill="#337ab7" stroke="#337ab7" points="54,-24 0,-24 0,0 54,0 54,-24"/>
<text text-anchor="middle" x="27" y="-9.6" font-family="Helvetica,sans-Serif" font-size="10.50" fill="#ffffff">Module</text>
</g>
<!-- Submodule -->
<g id="node2" class="node">
<title>Submodule</title>
<polygon fill="#5bc0de" stroke="#5bc0de" points="139.5,-24 72.5,-24 72.5,0 139.5,0 139.5,-24"/>
<text text-anchor="middle" x="106" y="-9.6" font-family="Helvetica,sans-Serif" font-size="10.50" fill="#ffffff">Submodule</text>
</g>
<!-- Subroutine -->
<g id="node3" class="node">
<title>Subroutine</title>
<polygon fill="#d9534f" stroke="#d9534f" points="222,-24 158,-24 158,0 222,0 222,-24"/>
<text text-anchor="middle" x="190" y="-9.6" font-family="Helvetica,sans-Serif" font-size="10.50" fill="#ffffff">Subroutine</text>
</g>
<!-- Function -->
<g id="node4" class="node">
<title>Function</title>
<polygon fill="#d94e8f" stroke="#d94e8f" points="294,-24 240,-24 240,0 294,0 294,-24"/>
<text text-anchor="middle" x="267" y="-9.6" font-family="Helvetica,sans-Serif" font-size="10.50" fill="#ffffff">Function</text>
</g>
<!-- Program -->
<g id="node5" class="node">
<title>Program</title>
<polygon fill="#f0ad4e" stroke="#f0ad4e" points="366,-24 312,-24 312,0 366,0 366,-24"/>
<text text-anchor="middle" x="339" y="-9.6" font-family="Helvetica,sans-Serif" font-size="10.50" fill="#ffffff">Program</text>
</g>
<!-- This Page&#39;s Entity -->
<g id="node6" class="node">
<title>This Page&#39;s Entity</title>
<polygon fill="none" stroke="#000000" points="481.5,-24 384.5,-24 384.5,0 481.5,0 481.5,-24"/>
<text text-anchor="middle" x="433" y="-9.6" font-family="Helvetica,sans-Serif" font-size="10.50" fill="#000000">This Page&#39;s Entity</text>
</g>
</g>
</svg>

    
    <p>Solid arrows point from a submodule to the (sub)module which it is
    descended from. Dashed arrows point from a module or program unit to 
    modules which it uses.
    </p>
    </div></div></div></div>
      </li>
      
      </ul>
    </div>
    


    
    <h2>NAME</h2>
<div class="codehilite"><pre><span></span><code>expand(3f) - [M_strings:NONALPHA] expand C-like escape sequences
</code></pre></div>

<h2>SYNOPSIS</h2>
<p>function expand(line,escape) result(lineout)</p>
<div class="codehilite"><pre><span></span><code>character(len=*)                      :: line
character(len=1),intent(in),optional  :: escape
character(len=:),allocatable          :: lineout
</code></pre></div>

<h2>DESCRIPTION</h2>
<div class="codehilite"><pre><span></span><code> <span class="nv">EXPAND</span><span class="ss">()</span> <span class="nv">expands</span> <span class="nv">sequences</span> <span class="nv">used</span> <span class="nv">to</span> <span class="nv">represent</span> <span class="nv">commonly</span> <span class="nv">used</span> <span class="nv">escape</span> <span class="nv">sequences</span>
 <span class="nv">or</span> <span class="nv">control</span> <span class="nv">characters</span>. <span class="nv">By</span> <span class="nv">default</span> ...

 <span class="nv">Escape</span> <span class="nv">sequences</span>
   \\     <span class="nv">backslash</span>
   \<span class="nv">a</span>     <span class="nv">alert</span> <span class="ss">(</span><span class="nv">BEL</span><span class="ss">)</span> <span class="o">--</span> <span class="nv">g</span> <span class="nv">is</span> <span class="nv">an</span> <span class="nv">alias</span> <span class="k">for</span> <span class="nv">a</span>
   \<span class="nv">b</span>     <span class="nv">backspace</span>
   \<span class="nv">c</span>     <span class="nv">suppress</span> <span class="nv">further</span> <span class="nv">output</span>
   \<span class="nv">e</span>     <span class="nv">escape</span>
   \<span class="nv">f</span>     <span class="nv">form</span> <span class="nv">feed</span>
   \<span class="nv">n</span>     <span class="nv">new</span> <span class="nv">line</span>
   \<span class="nv">r</span>     <span class="nv">carriage</span> <span class="k">return</span>
   \<span class="nv">t</span>     <span class="nv">horizontal</span> <span class="nv">tab</span>
   \<span class="nv">v</span>     <span class="nv">vertical</span> <span class="nv">tab</span>
   \<span class="nv">oNNN</span>  <span class="nv">byte</span> <span class="nv">with</span> <span class="nv">octal</span> <span class="nv">value</span> <span class="nv">NNN</span> <span class="ss">(</span><span class="mi">3</span> <span class="nv">digits</span><span class="ss">)</span>
   \<span class="nv">dNNN</span>  <span class="nv">byte</span> <span class="nv">with</span> <span class="nv">decimal</span> <span class="nv">value</span> <span class="nv">NNN</span> <span class="ss">(</span><span class="mi">3</span> <span class="nv">digits</span><span class="ss">)</span>
   \<span class="nv">xHH</span>   <span class="nv">byte</span> <span class="nv">with</span> <span class="nv">hexadecimal</span> <span class="nv">value</span> <span class="nv">HH</span> <span class="ss">(</span><span class="mi">2</span> <span class="nv">digits</span><span class="ss">)</span> <span class="o">--</span> <span class="nv">h</span> <span class="nv">is</span> <span class="nv">an</span> <span class="nv">alias</span> <span class="k">for</span> <span class="nv">x</span>

 <span class="nv">The</span> <span class="nv">default</span> <span class="nv">escape</span> <span class="nv">character</span> <span class="nv">is</span> <span class="nv">the</span> <span class="nv">backslash</span>, <span class="nv">but</span> <span class="nv">this</span> <span class="nv">may</span> <span class="nv">be</span> <span class="nv">changed</span> <span class="nv">using</span>
 <span class="nv">the</span> <span class="nv">optional</span> <span class="nv">parameter</span> <span class="nv">ESCAPE</span>.
</code></pre></div>

<h2>EXAMPLES</h2>
<div class="codehilite"><pre><span></span><code><span class="nv">Sample</span> <span class="nv">Program</span>:

 <span class="nv">program</span> <span class="nv">demo_expand</span>
 <span class="o">!</span>  <span class="nv">test</span> <span class="nv">filter</span> <span class="nv">to</span> <span class="nv">expand</span> <span class="nv">escape</span> <span class="nv">sequences</span> <span class="nv">in</span> <span class="nv">input</span> <span class="nv">lines</span>
 <span class="nv">use</span> <span class="nv">M_strings</span>, <span class="nv">only</span> : <span class="nv">expand</span>
 <span class="nv">character</span><span class="ss">(</span><span class="nv">len</span><span class="o">=</span><span class="mi">1024</span><span class="ss">)</span> :: <span class="nv">line</span>
 <span class="nv">integer</span>             :: <span class="nv">ios</span>
    <span class="nv">READFILE</span>: <span class="nv">block</span>
       <span class="k">do</span>
          <span class="nv">read</span><span class="ss">(</span><span class="o">*</span>,<span class="s1">&#39;</span><span class="s">(A)</span><span class="s1">&#39;</span>,<span class="nv">iostat</span><span class="o">=</span><span class="nv">ios</span><span class="ss">)</span><span class="nv">line</span>
          <span class="k">if</span><span class="ss">(</span><span class="nv">ios</span> <span class="o">/=</span> <span class="mi">0</span><span class="ss">)</span> <span class="k">exit</span> <span class="nv">READFILE</span>
          <span class="nv">write</span><span class="ss">(</span><span class="o">*</span>,<span class="s1">&#39;</span><span class="s">(a)</span><span class="s1">&#39;</span><span class="ss">)</span><span class="nv">trim</span><span class="ss">(</span><span class="nv">expand</span><span class="ss">(</span><span class="nv">line</span><span class="ss">))</span>
       <span class="nv">enddo</span>
    <span class="nv">endblock</span> <span class="nv">READFILE</span>
 <span class="k">end</span> <span class="nv">program</span> <span class="nv">demo_expand</span>

<span class="nv">Sample</span> <span class="nv">input</span>:

  \<span class="nv">e</span>[<span class="mi">2</span><span class="nv">J</span>
  \<span class="nv">tABC</span>\<span class="nv">tabc</span>
  \<span class="nv">tA</span>\<span class="nv">a</span>
  \<span class="nv">nONE</span>\<span class="nv">nTWO</span>\<span class="nv">nTHREE</span>
</code></pre></div>

<p>case('n','N');lineout=lineout//new_line()        ! %n     new line
case('t','T');lineout=lineout//c_horizontal_tab  ! %t     horizontal tab</p>
    

    <h3>Arguments</h3>
    
      
<table class="table table-striped varlist">
<thead><tr><th>Type</th>
<th>Intent</th><th>Optional</th>
<th>Attributes</th><th></th><th>Name</th><th></th></thead>



<tbody>

  
  
  
  
<tr>
  
  <td><span class="anchor" id="variable-line%7E2"></span>character(len=*)</td>
  <td></td>
  <td></td>
  
  <td></td><td>::</td>
  <td><strong>line</strong></td><td></td>
  
</tr>

  
  
  
  
<tr>
  
  <td><span class="anchor" id="variable-escape"></span>character(len=1),</td>
  <td>intent(in),</td>
  <td>optional</td>
  
  <td></td><td>::</td>
  <td><strong>escape</strong></td><td></td>
  
</tr>

</tbody>
</table>

    
    
    
    
    
    
    
   <h3>Return Value <small><span class="anchor" id="variable-lineout"></span>character(len=:),
  allocatable</small></h3>
    
    
    
    
     
    <br>

    <section class="visible-xs visible-sm hidden-md">
      
<h3>Contents</h3>
 





















<em>None</em>


    </section>
    <br class="visible-xs visible-sm hidden-md">

    

    
    
    
    
    

    
    
    
    
    


    
    
    
    
    </div>
  </div>


    <hr>    
    </div> <!-- /container -->
    <footer>
      <div class="container">
      <div class="row">
        <div class="col-xs-6 col-md-6"><p>FLUBIO was developed by Edoardo Alinovi and Joel Guerrero<br>&copy; 2021 <a rel="license" href="http://creativecommons.org/licenses/by-nc/4.0/"><img alt="Creative Commons License" style="border-width:0" src="https://i.creativecommons.org/l/by-nc/4.0/80x15.png" /></a>
                                          </p>
        </div>
        <div class="col-xs-6 col-md-6">
          <p class="text-right">
            Documentation generated by 
            <a href="https://github.com/Fortran-FOSS-Programmers/ford">FORD</a>
            
            
          </p>
        </div>
      </div>
      <br>
      </div> <!-- /container -->    
    </footer>

    <!-- Bootstrap core JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
<!--
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
-->
    <script src="../js/bootstrap.min.js"></script>
    <!-- IE10 viewport hack for Surface/desktop Windows 8 bug -->
    <script src="../js/ie10-viewport-bug-workaround.js"></script>

    <!-- MathJax JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
    <script type="text/x-mathjax-config">
      MathJax.Hub.Config({
        TeX: { extensions: ['AMSmath.js','AMSsymbols.js','noErrors.js','noUndefined.js'], equationNumbers: { autoNumber: 'AMS' } },
        jax: ['input/TeX','input/MathML','output/HTML-CSS'],
        extensions: ['tex2jax.js','mml2jax.js','MathMenu.js','MathZoom.js']
      });
    </script>
    
    <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
    
    
    <script src="../tipuesearch/tipuesearch_content.js"></script>
    <script src="../tipuesearch/tipuesearch_set.js"></script>
    <script src="../tipuesearch/tipuesearch.js"></script>
    
    
  </body>
</html>